/*
    gcpdemo.cpp  -- demo of garbage collecting
       and self policing pointers.
       
    This file is deliberately filled with commented
    out lines to test various pointer bugs and
    syntax forms of using gcp.h.
*/

//#define GCP_NO_TEMPLATES
//#define GCP_NDEBUG
//#define GCP_ABORT_ON_WARN
//#define GCP_LOG_ERRORS
#ifdef GCP_NDEBUG
    #include <iostream.h>
    #include <iomanip.h>
#endif


#ifdef GCP_NO_TEMPLATES // not required with templates!
    struct ints;
    #define SPP_DECL ints
    #define GCP_TPL spp(ints)
    #include "gcp.hf"
#else
    #include "gcp.h"
#endif

struct ints {
  int x, y;
  spp(ints) next;
  ints()  { x = y = 0; next = 0; }
  ints& operator=(int x)
    { this->x = y = x; return *this; }
};


#ifdef GCP_NO_TEMPLATES // not required with templates!
    #define GCO_SERVICES_DEF
    #define SPP_DEF ints
    #define GCP_TPL spp(ints)
    #include "gcp.hf"
#else
    SPP_DECL(ints)
#endif

GCP_ERROR_LOG("gcpdemo.log")

main()
{
  spp_init(ints,i) = new_spp(i) ints[5];
  for (unsigned j = 0; j < 5; j++)
     i[j].x = (i+j)->y = j;
  spp_init(ints,k) = i;
//  i = 0;
//  GCP_STAMP(i,i[1]);
  for (j = 0; j < 5; j++)
     cout << k[j].x << " " << (*(k+j)).y  << endl;
  *((&*i)-1) = 2;            // breach front fence
  (*((&i[4]) + 1)) = 2;  // breach back fence
  delete_sp(i);
//  GCP_STAMP(k,k[1]);
  delete_spa(k);
//  GCP<int> m = (int *)new(GCP<int>::heap) char[3];
//gcnsp(int) m;
//  new_gcnsp(int) int[10];
//  GCP_STAMP(k,k[6]);
  return 0;
} 
